import QtQuick 6.7
import QtQuick.Studio.Components 1.0

GroupItem {
    id: leftGroupItem

    MouseArea {
        id: mouseArea
        anchors.fill: parent

        Connections {
            target: mouseArea
            onClicked: if (leftGroupItem.state === "OnClicked") {
                           leftGroupItem.state = "Base State"
                       } else {
                           leftGroupItem.state = "OnClicked"
                       }
        }

        Connections {
            target: mouseArea
            onClicked: if (rectangle.state === "SimpleEffectState"
                               && simpleBorder.opacity === 1) {
                           simpleBorder.opacity = 0
                           simpleBorder.visible = false
                       } else if (rectangle.state === "SimpleEffectState"
                                  && simpleBorder.opacity === 0) {
                           simpleBorder.opacity = 1
                           simpleBorder.visible = true
                       }
        }

        Connections {
            target: mouseArea
            onClicked: if (rectangle.state === "ComboEffectState"
                               && comboGroup.opacity === 1) {
                           comboGroup.opacity = 0
                           comboGroup.visible = false
                       } else if (rectangle.state === "ComboEffectState"
                                  && comboGroup.opacity === 0) {
                           comboGroup.opacity = 1
                           comboGroup.visible = true
                       }
        }

        Connections {
            target: mouseArea
            onClicked: if (rectangle.state === "AnimatedEffectState"
                               && animationBorder.opacity === 1) {
                           animationBorder.opacity = 0
                           animationBorder.visible = false
                       } else if (rectangle.state === "AnimatedEffectState"
                                  && animationBorder.opacity === 0) {
                           animationBorder.opacity = 1
                           animationBorder.visible = true
                       }
        }

        Connections {
            target: mouseArea
            onClicked: if (rectangle.state === "WeatherEffectState"
                               && weatherGroup.opacity === 1) {
                           weatherGroup.opacity = 0
                           weatherGroup.visible = false
                       } else if (rectangle.state === "WeatherEffectState"
                                  && weatherGroup.opacity === 0) {
                           weatherGroup.opacity = 1
                           weatherGroup.visible = true
                       }
        }
    }

    Text {
        id: _text
        color: "#ffffff"
        text: qsTr("^")
        anchors.verticalCenter: parent.verticalCenter
        font.pixelSize: 30
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        anchors.horizontalCenter: parent.horizontalCenter
        rotation: -90
    }
    states: [
        State {
            name: "OnClicked"

            PropertyChanges {
                target: _text
                rotation: 90
            }
        }
    ]
}
